<?php

/**
 * @package        Case
 * @author         GoGetThemes
 * @copyright      2015 GoGetThemes
 * @version        Release: v1.0
 */

function theme_option($key, $child = null)
{
    global $theme_data;

    if (!$child) {
        return isset($theme_data[$key]) ? $theme_data[$key] : false;
    } else {

        return isset($theme_data[$key]) && isset($theme_data[$key][$child]) ? $theme_data[$key][$child] : false;
    }
}


function ggt_get_photogallery_image($index)
{

    $url = null;

    $gallery = null;
    $quick_gallery = null;

    if (is_singular("photogallery")) {
        $gallery = ggt_get_field('gallery_items');
        if(ggt_get_field("quick_gallery_mode")){
            $tmp_quick_gallery = ggt_get_field("quick_gallery");
            $quick_gallery = isset($tmp_quick_gallery) && $tmp_quick_gallery != "" ? $tmp_quick_gallery : null;
        }
    } else if (is_page_template("page-singlehome.php")) {
        global $post;
        $type = get_field("home_post_type", $post->ID);
        if ($type == "photogallery") {
            $gallery_id = get_field("photogallery");
            $gallery = ggt_get_field('gallery_items', $gallery_id->ID);

            if(ggt_get_field("quick_gallery_mode", $gallery_id->ID)){
                $tmp_quick_gallery = ggt_get_field("quick_gallery", $gallery_id->ID);
                $quick_gallery = isset($tmp_quick_gallery) && $tmp_quick_gallery != "" ? $tmp_quick_gallery : null;
            }
        }
    }

    if (isset($gallery)
        && is_array($gallery)
        && sizeof($gallery) >= $index
        && isset($gallery[$index])
    ) {
        /** standart image */

        if (isset($gallery[$index]["image"])
            && isset($gallery[$index]["image"]["url"])
        ) {
            $url = $gallery[$index]["image"]["url"];
        } /** layouts */

        else if (isset($gallery[$index]["acf_fc_layout"])) {
            switch ($gallery[$index]["acf_fc_layout"]) {
                /** woo product */
                case "woo_product":
                    if (isset($gallery[$index]["product"])) {
                        $product = $gallery[$index]["product"];
                        if (isset($product->ID)) {
                            $url = ggt_get_featured($product->ID);
                        }
                    }
                    break;

                /** woo product */
                case "vimeo_video":
                case "youtube_video":
                case "selfhosted_video":
                    if (isset($gallery[$index]["video_cover"])) {
                        $image = $gallery[$index]["video_cover"];
                        $src = isset($image["url"]) ? $image["url"] : null;
                        if (isset($src)) {
                            $url = $src;
                        }
                    }
                    break;
            }
        }
    }

    if(isset($quick_gallery) && is_array($quick_gallery) && sizeof($quick_gallery) >= $index && isset($quick_gallery[$index]) && isset($quick_gallery[$index]["url"])){
        $url = $quick_gallery[$index]["url"];
    }

    return $url;
}

function ggt_facebook_meta()
{
    if (is_singular("portfolio") || is_singular("photogallery") || is_page()):
        $url = ggt_get_featured(get_the_ID());
        if (is_singular("photogallery") && isset($_GET["photo"])) {
            $tmp_url = ggt_get_photogallery_image($_GET["photo"]);
            if (isset($tmp_url)) {
                $url = $tmp_url;
            }
        }
        ?>
        <meta property="og:title" content="<?php the_title_attribute(); ?>"/>
        <meta property="og:description" content="<?php esc_attr_e(get_the_excerpt()); ?>"/>
        <meta property="og:image" content="<?php echo esc_url($url); ?>"/>
        <meta name="twitter:title" content="<?php the_title_attribute(); ?>" />
        <meta name="twitter:image" content="<?php echo esc_url($url); ?>" />
        <meta name="twitter:card" content="photo" />
    <?php
    endif;
}

function ggt_gallery_count($ID)
{
    if (ggt_get_field('quick_gallery_mode', $ID)) {
        return sizeof(ggt_get_field('quick_gallery', $ID));
    } else {
        return sizeof(ggt_get_field('gallery_items', $ID));
    }
}

function ggt_get_gf_options_array()
{
    $result = array();
    $gf = ggt_google_fonts();
    foreach ($gf as $f) {
        $result[$f] = $f;
    }
    return $result;
}

function ggt_print_filters_for($hook = '')
{
    global $wp_filter;
    if (empty($hook) || !isset($wp_filter[$hook]))
        return;

    print '<pre>';
    print_r($wp_filter[$hook]);
    print '</pre>';
}

/** ACF dummy functions */

function ggt_get_field($name, $id = null)
{
    if (function_exists("get_field")) {
        return $id ? get_field($name, $id) : get_field($name);
    } else {
        return false;
    }
}

function ggt_get_sub_field($name, $id = null)
{
    if (function_exists("get_sub_field")) {
        return $id ? get_sub_field($name, $id) : get_sub_field($name);
    } else {
        return false;
    }
}

function ggt_the_field($name, $id = null)
{
    if (function_exists("the_field")) {
        $id ? the_field($name, $id) : the_field($name);
    }
}

function ggt_have_rows($name, $id = null)
{
    if (function_exists("have_rows")) {
        return $id ? have_rows($name, $id) : have_rows($name);
    } else {
        return false;
    }
}

function ggt_the_row()
{
    if (function_exists("the_row")) {
        the_row();
    }
}

function ggt_maybe_get_categories()
{
    $cat = ggt_get_field("select_category");
    $result = "";
    if (isset($cat) && is_array($cat) && sizeof($cat) > 0) {
        $result = trim(implode(",", $cat), ",");
    }
    return $result;
}

/*
 * Paging Navigation
 */

function ggt_paging_nav()
{
    // Don't print empty markup if there's only one page.
    if ($GLOBALS['wp_query']->max_num_pages < 2) {
        return;
    }

    $paged = get_query_var('paged') ? intval(get_query_var('paged')) : 1;
    $pagenum_link = html_entity_decode(get_pagenum_link());
    $query_args = array();
    $url_parts = explode('?', $pagenum_link);

    if (isset($url_parts[1])) {
        wp_parse_str($url_parts[1], $query_args);
    }

    $pagenum_link = remove_query_arg(array_keys($query_args), $pagenum_link);
    $pagenum_link = trailingslashit($pagenum_link) . '%_%';

    $format = $GLOBALS['wp_rewrite']->using_index_permalinks() && !strpos($pagenum_link, 'index.php') ? 'index.php/' : '';
    $format .= $GLOBALS['wp_rewrite']->using_permalinks() ? user_trailingslashit('page/%#%', 'paged') : '?paged=%#%';

    // Set up paginated links.
    $links = paginate_links(array(
        'base' => $pagenum_link,
        'format' => $format,
        'total' => $GLOBALS['wp_query']->max_num_pages,
        'current' => $paged,
        'mid_size' => 1,
        'add_args' => array_map('urlencode', $query_args),
        'prev_text' => __('&larr; Previous', 'GoGetThemes'),
        'next_text' => __('Next &rarr;', 'GoGetThemes'),
    ));

    if ($links) :

        ?>
        <nav class="navigation paging-navigation" role="navigation">
            <div class="pagination loop-pagination">
                <?php echo $links; ?>
            </div>
            <!-- .pagination -->
        </nav><!-- .navigation -->
    <?php
    endif;
}

function ggt_post_nav()
{
    // Don't print empty markup if there's nowhere to navigate.
    $previous = (is_attachment()) ? get_post(get_post()->post_parent) : get_adjacent_post(false, '', true);
    $next = get_adjacent_post(false, '', false);

    if (!$next && !$previous) {
        return;
    }

    ?>
    <div class="navigation post-navigation" role="navigation">
        <div class="nav-links">
            <?php
            if (is_attachment()) :
                previous_post_link('%link', __('<span class="meta-nav">Published In</span><div>%title</div>', 'GoGetThemes'));
            else :
                previous_post_link('%link', __('<span class="meta-nav-left">Previous Post</span>%title', 'GoGetThemes'));
                next_post_link('%link', __('<span class="meta-nav-right">Next Post</span>%title', 'GoGetThemes'));
            endif;
            ?>
        </div>
        <!-- .nav-links -->
    </div><!-- .navigation -->
<?php
}

function ggt_post_prev()
{
    // Don't print empty markup if there's nowhere to navigate.
    $previous = (is_attachment()) ? get_post(get_post()->post_parent) : get_adjacent_post(false, '', true);

    if (!$previous) {
        return;
    }
    ?>
    <nav role="navigation">
        <div class="post-arrow-prev">
            <?php
            previous_post_link('%link', __('<span>%title</span>', 'GoGetThemes'));
            ?>
        </div>
        <!-- .nav-links -->
    </nav><!-- .navigation -->
<?php
}

function ggt_post_next()
{
    $next = get_adjacent_post(false, '', false);

    if (!$next) {
        return;
    }

    ?>
    <nav role="navigation">
        <div class="post-arrow-next">
            <?php
            next_post_link('%link', __('<span>%title</span>', 'GoGetThemes'));
            ?>
        </div>
        <!-- .nav-links -->
    </nav><!-- .navigation -->
<?php
}

#-----------------------------------------------------------------#
# Changing page's title
#-----------------------------------------------------------------#

function ggt_wp_title($title, $sep)
{
    global $paged, $page;

    if (is_feed()) {
        return $title;
    }

    // Add the site name.
    $title .= get_bloginfo('name');

    // Add the site description for the home/front page.
    $site_description = get_bloginfo('description', 'display');
    if ($site_description && (is_home() || is_front_page())) {
        $title = "$title $sep $site_description";
    }

    // Add a page number if necessary.
    if ($paged >= 2 || $page >= 2) {
        $title = "$title $sep " . sprintf(__('Page %s', 'GoGetThemes'), max($paged, $page));
    }

    return $title;
}

add_filter('wp_title', 'ggt_wp_title', 10, 2);


//============================================================ Breadcrumbs

function ggt_breadcrumbs()
{
    $showOnHome = 1; // 1 - show breadcrumbs on the homepage, 0 - don't show
    $delimiter = '<span class="bc_arr"><i class="fa fa-angle-right"></i></span>'; // delimiter between crumbs
    $home = 'Home'; // text for the 'Home' link
    $showCurrent = 1; // 1 - show current post/page title in breadcrumbs, 0 - don't show
    $before = '<li><span class="current">'; // tag before the current crumb
    $after = '</span></li>'; // tag after the current crumb

    global $post;
    $homeLink = home_url();

    if (is_home() || is_front_page()) {
        if ($showOnHome == 1) echo '<div id="crumbs"><ul class="unstyled inline"><li><a href="' . esc_url($homeLink) . '">' . $home . '</a>' . $delimiter . '</li></ul></div>';
    } else {
        echo '<div id="crumbs"><ul class="unstyled inline"><li><a href="' . esc_url($homeLink) . '">' . $home . '</a>' . $delimiter . '</li> ';

        if (is_category()) {
            $thisCat = get_category(get_query_var('cat'), false);
            if ($thisCat->parent != 0) echo get_category_parents($thisCat->parent, TRUE, ' ' . $delimiter . ' ');
            echo $before . 'Archive by category "' . single_cat_title('', false) . '"' . $after;

        } elseif (is_search()) {
            echo $before . 'Search results for "' . get_search_query() . '"' . $after;

        } elseif (is_day()) {
            echo '<li><a href="' . get_year_link(get_the_time('Y')) . '">' . get_the_time('Y') . '</a>' . $delimiter . '</li> ';
            echo '<li><a href="' . get_month_link(get_the_time('Y'), get_the_time('m')) . '">' . get_the_time('F') . '</a>' . $delimiter . '</li> ';
            echo $before . get_the_time('d') . $after;

        } elseif (is_month()) {
            echo '<li><a href="' . get_year_link(get_the_time('Y')) . '">' . get_the_time('Y') . '</a>' . $delimiter . '</li> ';
            echo $before . get_the_time('F') . $after;

        } elseif (is_year()) {
            echo $before . get_the_time('Y') . $after;

        } elseif (is_single() && !is_attachment()) {
            if (get_post_type() != 'post') {
                $post_type = get_post_type_object(get_post_type());
                $slug = $post_type->rewrite;
                $cat_link = get_post_type_archive_link($post_type->name);
                echo '<li><a href="' . esc_url($cat_link) . '">' . $post_type->labels->singular_name . '</a>' . $delimiter . '</li>';
                if ($showCurrent == 1) echo $before . get_the_title() . $after;
            } else {
                $cat = get_the_category();
                $cat = $cat[0];

                //var_dump($cat);
                $cats = get_category_parents($cat, TRUE, ' ' . $delimiter . ' ');
                //var_dump($cats);
                if ($showCurrent == 0) $cats = preg_replace("#^(.+)\s$delimiter\s$#", "$1", $cats);
                //echo $cats;
                global $post;
                $cat_array = get_the_category($post->ID);
                //var_dump($cat_array);
                echo '<li><a href="' . get_category_link($cat_array[0]->term_id) . '">' . $cat_array[0]->name . '</a>' . $delimiter . '</li>';
                if ($showCurrent == 1) echo $before . get_the_title() . $after;
            }

        } elseif (!is_single() && !is_page() && get_post_type() != 'post' && !is_404()) {
            $post_type = get_post_type_object(get_post_type());
            echo $before . $post_type->labels->singular_name . $after;

        } elseif (is_attachment()) {
            $parent = get_post($post->post_parent);
            $cat = get_the_category($parent->ID);
            $cat = $cat[0];
            if (!is_wp_error($cat_parents = get_category_parents($cat, TRUE, '' . $delimiter . ''))) {
                echo '<li>' . get_category_parents($cat, TRUE, ' ' . $delimiter . ' ') . '</li>';
            }
            echo '<li><a href="' . get_permalink($parent) . '">' . $parent->post_title . '</a>' . $delimiter . '</li>';
            if ($showCurrent == 1) echo '<li>' . $before . get_the_title() . $after . '</li>';

        } elseif (is_page() && !$post->post_parent) {
            if ($showCurrent == 1) echo $before . get_the_title() . $after;

        } elseif (is_page() && $post->post_parent) {
            $parent_id = $post->post_parent;
            $breadcrumbs = array();
            while ($parent_id) {
                $page = get_post($parent_id);
                $breadcrumbs[] = '<li><a href="' . get_permalink($page->ID) . '">' . get_the_title($page->ID) . '</a>' . $delimiter . '</li>';
                $parent_id = $page->post_parent;
            }
            $breadcrumbs = array_reverse($breadcrumbs);
            for ($i = 0; $i < count($breadcrumbs); $i++) {
                echo $breadcrumbs[$i];
            }
            if ($showCurrent == 1) echo $before . get_the_title() . $after;

        } elseif (is_tag()) {
            echo $before . 'Posts tagged "' . single_tag_title('', false) . '"' . $after;

        } elseif (is_author()) {
            global $author;
            $userdata = get_userdata($author);
            echo $before . 'Articles posted by ' . $userdata->display_name . $after;

        } elseif (is_404()) {
            echo $before . 'Error 404' . $after;
        }

        if (get_query_var('paged')) {
            if (is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author()) echo ' (';
            echo __('Page', 'GoGetThemes') . ' ' . get_query_var('paged');
            if (is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author()) echo ')';
        }
        echo '</ul></div>';
    }
}

/*
 * Adda protocol to bad urls
 */

function validate_link($str)
{
    if (strpos($str, "http://") === false && strpos($str, "https://") === false && strpos($str, "ftp://") === false) {
        return "http://" . $str;
    } else {
        return $str;
    }
}

function ggt_menu()
{
    $menu_args = array(
        'theme_location' => 'vertical',
        'container' => 'div',
        'container_class' => '',
        'container_id' => '',
        'menu_class' => 'menu',
        'menu_id' => 'respon-menu',
        'echo' => true,
        'before' => '',
        'after' => '',
        'link_before' => '',
        'link_after' => '',
        'items_wrap' => '<nav id="primary-menu"><div class="menu-container"><a class="toggleMenu" href="#">Menu</a><ul id="%1$s" class="%2$s">%3$s</ul></div></nav>'
    );
    wp_nav_menu($menu_args);
}

/*
 * HEX To RGB / RGBA
 */

function hex2rgb($hex, $opacity = null, $as_array = false)
{
    $hex = str_replace("#", "", $hex);

    if (strlen($hex) == 3) {
        $r = hexdec(substr($hex, 0, 1) . substr($hex, 0, 1));
        $g = hexdec(substr($hex, 1, 1) . substr($hex, 1, 1));
        $b = hexdec(substr($hex, 2, 1) . substr($hex, 2, 1));
    } else {
        $r = hexdec(substr($hex, 0, 2));
        $g = hexdec(substr($hex, 2, 2));
        $b = hexdec(substr($hex, 4, 2));
    }

    if ($as_array) {
        return array("red" => $r, "green" => $g, "blue" => $b);
    } else if ($opacity != null) {
        $rgb = 'rgba(' . $r . ', ' . $g . ', ' . $b . ', ' . $opacity . ')';
    } else {
        $rgb = 'rgb(' . $r . ', ' . $g . ', ' . $b . ')';
    }

    //return implode(",", $rgb); // returns the rgb values separated by commas
    return $rgb; // returns an array with the rgb values
}

/**
 * Custom sizes for portfolio
 * @param $box_size
 */

function get_portfolio_thumb_size($box_size, $columns)
{
    $thumb_size = 'full';

    switch ($box_size) {
        case '11':
            switch ($columns) {
                case 2:
                    $thumb_size = 'img1920';
                    break; // use full image sizes
                case 3:
                    $thumb_size = 'img960';
                    break;
                case 4:
                    $thumb_size = 'img600';
                    break;
                case 6:
                    $thumb_size = 'img480';
                    break;
                case 12:
                    $thumb_size = 'img300';
                    break;
            }
            break;

        default: // more than 1x1
            switch ($columns) {
                case 2:
                case 3:
                    $thumb_size = 'full';
                    break;
                case 4:
                    $thumb_size = 'img1920';
                    break;
                case 6:
                    $thumb_size = 'img960';
                    break;
                case 12:
                    $thumb_size = 'img480';
                    break;
            }
            break;
    }
    return $thumb_size;
}

function get_portfolio_masonry_thumb_size($columns)
{
    $thumb_size = 'full';

    switch ($columns) {
        case 2:
            $thumb_size = 'msimg1920';
            break; // use full image sizes
        case 3:
            $thumb_size = 'msimg960';
            break;
        case 4:
            $thumb_size = 'msimg600';
            break;
        case 6:
            $thumb_size = 'msimg480';
            break;
        case 12:
            $thumb_size = 'msimg300';
            break;
    }

    return $thumb_size;
}

function parse_youtube_link($url)
{
    $pattern = '#(?:https?://)?'; # Optional URL scheme. Either http or https.
    $pattern .= '(?:www\.)?'; #  Optional www subdomain.
    $pattern .= '(?:'; #  Group host alternatives:
    $pattern .= 'youtu\.be/'; #    Either youtu.be,
    $pattern .= '|youtube\.com'; #    or youtube.com
    $pattern .= '(?:'; #    Group path alternatives:
    $pattern .= '/embed/'; #      Either /embed/,
    $pattern .= '|/v/'; #      or /v/,
    $pattern .= '|/watch\?v='; #      or /watch?v=,
    $pattern .= '|/watch\?.+&v='; #      or /watch?other_param&v=
    $pattern .= ')'; #    End path alternatives.
    $pattern .= ')'; #  End host alternatives.
    $pattern .= '([\w-]{11})'; # 11 characters (Length of Youtube video ids).
    $pattern .= '(?:.+)?#x'; # Optional other ending URL parameters.
    preg_match($pattern, $url, $matches);
    return (isset($matches[1])) ? $matches[1] : false;
}

function vimeo_video_id($url)
{
    $regex = '~
		# Match Vimeo link and embed code
		(?:<iframe [^>]*src=")?         # If iframe match up to first quote of src
		(?:                             # Group vimeo url
				https?:\/\/             # Either http or https
				(?:[\w]+\.)*            # Optional subdomains
				vimeo\.com              # Match vimeo.com
				(?:[\/\w]*\/videos?)?   # Optional video sub directory this handles groups links also
				\/                      # Slash before Id
				([0-9]+)                # $1: VIDEO_ID is numeric
				[^\s]*                  # Not a space
		)                               # End group
		"?                              # Match end quote if part of src
		(?:[^>]*></iframe>)?            # Match the end of the iframe
		(?:<p>.*</p>)?                  # Match any title information stuff
		~ix';

    preg_match($regex, $url, $matches);

    return $matches[1];
}

function theme_password_form()
{
    global $post;
    $label = 'pwbox-' . (empty($post->ID) ? rand() : $post->ID);
    $o = '<form action="' . esc_url(site_url('wp-login.php?action=postpass', 'login_post')) . '" method="post">
    ' . __("To view this protected content, enter the password below:", "GoGetThemes") . '
    <div class="passwrap clearfix"><input name="post_password" id="' . esc_attr($label) . '" type="password" size="20" maxlength="20" /><div class="submit-wrap"><input type="submit" name="Submit" value="' . esc_attr__("Submit") . '" /></div></div>
    </form>
    ';
    return $o;
}

add_filter('the_password_form', 'theme_password_form');


function has_custom_sidebar()
{
    global $post;
    $result = get_post_meta($post->ID, 'sbg_selected_sidebar_replacement', true);
    return is_array($result) && !empty($result) && $result[0] != "0" && ggt_get_field("sidebar_position") != "none";
}

function is_left_sidebar()
{
    return has_custom_sidebar() && ggt_get_field("sidebar_position") == "left";
}

function is_right_sidebar()
{
    return has_custom_sidebar() && ggt_get_field("sidebar_position") == "right";
}

function get_content_cols()
{
    return !has_custom_sidebar() ? "col-lg-12 col-md-12 col-xs-12" : "col-lg-9 col-md-9 col-xs-9";
}

function ggt_get_featured($ID, $size = "full")
{
    $featured = wp_get_attachment_image_src(get_post_thumbnail_id($ID), $size);
    return $featured[0];
}

function ggt_get_featured_object($ID)
{
    $featuredID = get_post_thumbnail_id($ID);
    $featuredMeta = wp_get_attachment_metadata($featuredID);
    $imageObject = $featuredMeta;
    $featured = wp_get_attachment_image_src($featuredID);
    $imageObject["url"] = $featured[0];
    return $imageObject;
}

function ggt_get_thumb($ID)
{
    $featured = wp_get_attachment_image_src(get_post_thumbnail_id($ID), "thumbnail");
    return $featured[0];
}

add_action("wp_ajax_gallery_add_to_cart", "add_photo_to_cart");
add_action("wp_ajax_nopriv_gallery_add_to_cart", "add_photo_to_cart");

function add_photo_to_cart()
{
    global $woocommerce;

    $product_id = $_POST["product_id"];
    $quantity = $_POST["quantity"];
    $variation_id = isset($_POST["variation_id"]) ? $_POST["variation_id"] : '';
    $variation = isset($_POST["variation_attributes"]) ? json_decode(stripslashes($_POST["variation_attributes"]), true) : array();

    $result = $woocommerce->cart->add_to_cart($product_id, $quantity, $variation_id, $variation);
    echo json_encode(array("result" => $result));
    die(0);
}

/**
 * Resets global page object
 * for use inside Single Home page
 * bridge template
 */

function ggt_single_home_check()
{
    global $post;
    if (isset($post) && isset($post->post_type) && $post->post_type == "page") { // we're in a gallery/portfolio home page template, most likely ))
        $type = ggt_get_field("home_post_type", $post->ID);
        if ($type == "photogallery") {
            $new_post = get_post(ggt_get_field("photogallery"), $post->ID);
        } else {
            $new_post = get_post(ggt_get_field("portfolio"), $post->ID);
        }
        $post = $new_post;
    }
}

function ggt_maybe_post_icon()
{
    global $post;
    if (!has_post_thumbnail($post->ID) && get_post_format() !== 'gallery'
        || ((get_post_format() == 'gallery') && !ggt_get_field('gallery_items') && !get_post_gallery_images(get_the_ID()))
    ): ?>
        <div class="post-format-icon"></div>
    <?php endif;
}

function ggt_trim_excerpt($post_or_id, $excerpt_more = ' [...]')
{
    if (is_object($post_or_id)) $postObj = $post_or_id;
    else $postObj = get_post($post_or_id);

    $raw_excerpt = $text = $postObj->post_excerpt;
    if ('' == $text) {
        $text = $postObj->post_content;

        $text = strip_shortcodes($text);

        $text = apply_filters('the_content', $text);
        $text = str_replace(']]>', ']]&gt;', $text);
        $text = strip_tags($text);
        $excerpt_length = apply_filters('excerpt_length', 55);

        // don't automatically assume we will be using the global "read more" link provided by the theme
        // $excerpt_more = apply_filters('excerpt_more', ' ' . '[...]');
        $words = preg_split("/[\n\r\t ]+/", $text, $excerpt_length + 1, PREG_SPLIT_NO_EMPTY);
        if (count($words) > $excerpt_length) {
            array_pop($words);
            $text = implode(' ', $words);
            $text = $text . $excerpt_more;
        } else {
            $text = implode(' ', $words);
        }
    }
    return apply_filters('wp_trim_excerpt', $text, $raw_excerpt);
}

/**
 * Get featured image dimensions
 * @param $postID
 * @param string $size
 * @return mixed
 */

function ggt_featured_w($postID, $size = "full")
{
    $image_data = wp_get_attachment_image_src(get_post_thumbnail_id($postID), $size);
    return $image_data[1]; // width
}

function ggt_featured_h($postID, $size = "full")
{
    $image_data = wp_get_attachment_image_src(get_post_thumbnail_id($postID), $size);
    return $image_data[2];
}

/**
 *
 */

add_filter('upload_mimes', 'ggt_upload_mimes');
function ggt_upload_mimes($existing_mimes = array())
{
    $existing_mimes['woff'] = 'font/woff';
    $existing_mimes['ttf'] = 'font/ttf';
    $existing_mimes['svg'] = 'font/svg';
    $existing_mimes['eot'] = 'font/eot';
    return $existing_mimes;
}

/**
 *
 */

function ggt_custom_fonts()
{

    /**
     * Custom Font 1
     */
    if (theme_option("font1-switch")) {
        ?>
        <style>
            @font-face {
                font-family: "<?php echo theme_option("font1-name"); ?>";
                src: url("<?php echo theme_option("font1-eot", "url"); ?>");
                src: url("<?php echo theme_option("font1-eot", "url"); ?>#iefix") format("embedded-opentype"),
                url("<?php echo theme_option("font1-woff", "url"); ?>") format("woff"),
                url("<?php echo theme_option("font1-ttf", "url"); ?>") format("truetype"),
                url("<?php echo theme_option("font1-svg", "url"); ?>#<?php echo theme_option("font1-name"); ?>") format("svg");
                font-weight: normal;
                font-style: normal;
            }
        </style>
    <?php
    }

    /**
     * Custom Font 2
     */
    if (theme_option("font2-switch")) {
        ?>
        <style>
            @font-face {
                font-family: "<?php echo theme_option("font2-name"); ?>";
                src: url("<?php echo theme_option("font2-eot", "url"); ?>");
                src: url("<?php echo theme_option("font2-eot", "url"); ?>#iefix") format("embedded-opentype"),
                url("<?php echo theme_option("font2-woff", "url"); ?>") format("woff"),
                url("<?php echo theme_option("font2-ttf", "url"); ?>") format("truetype"),
                url("<?php echo theme_option("font2-svg", "url"); ?>#<?php echo theme_option("font2-name"); ?>") format("svg");
                font-weight: normal;
                font-style: normal;
            }
        </style>
    <?php
    }

    /**
     * Custom Font 3
     */
    if (theme_option("font3-switch")) {
        ?>
        <style>
            @font-face {
                font-family: "<?php echo theme_option("font3-name"); ?>";
                src: url("<?php echo theme_option("font3-eot", "url"); ?>");
                src: url("<?php echo theme_option("font3-eot", "url"); ?>#iefix") format("embedded-opentype"),
                url("<?php echo theme_option("font3-woff", "url"); ?>") format("woff"),
                url("<?php echo theme_option("font3-ttf", "url"); ?>") format("truetype"),
                url("<?php echo theme_option("font3-svg", "url"); ?>#<?php echo theme_option("font3-name"); ?>") format("svg");
                font-weight: normal;
                font-style: normal;
            }
        </style>
    <?php
    }
}

add_action('wp_head', 'ggt_custom_fonts');


function ggt_adjust_color($hex, $steps)
{
    // Steps should be between -255 and 255. Negative = darker, positive = lighter
    $steps = max(-255, min(255, $steps));

    // Normalize into a six character long hex string
    $hex = str_replace('#', '', $hex);
    if (strlen($hex) == 3) {
        $hex = str_repeat(substr($hex, 0, 1), 2) . str_repeat(substr($hex, 1, 1), 2) . str_repeat(substr($hex, 2, 1), 2);
    }

    // Split into three parts: R, G and B
    $color_parts = str_split($hex, 2);
    $return = '#';

    foreach ($color_parts as $color) {
        $color = hexdec($color); // Convert to decimal
        $color = max(0, min(255, $color + $steps)); // Adjust color
        $return .= str_pad(dechex($color), 2, '0', STR_PAD_LEFT); // Make two char hex code
    }

    return $return;
}

function ggt_is_blog()
{
    global $post;
    $posttype = get_post_type($post);
    return (((is_archive()) || (is_author()) || (is_category()) || (is_home()) || (is_single()) || (is_tag())) && ($posttype == 'post') || (is_search())) ? true : false;
}

function ggt_footer_skin()
{
    $skin = theme_option("footer_skin") ? theme_option("footer_skin") : "dark";
    return "section-" . $skin;
}

function ggt_portrait_thumb()
{
    if (has_post_thumbnail(get_the_ID())):
        ?>
        <div class="portrait-img"
             style="background-image: url(<?php echo esc_url(ggt_get_featured(get_the_ID())); ?>);"></div>
    <?php
    endif;
}

function ggt_smart_excerpt()
{
    global $post;

    if (strpos($post->post_content, "<!--more-->") !== false) {
        the_content();
    } else {
        the_excerpt();
    }
}

/**
 * Featured image skin
 * @param null $ID
 * @return string
 */

function ggt_get_featured_skin($ID = null)
{

    if (null == $ID) {
        global $post;
        $ID = $post->ID;
    }
    return ggt_get_field("featured_skin") ? "dark" : "light";
}

function ggt_is_woo_page()
{
    return (
        function_exists("is_cart") && is_cart()
        || function_exists("is_checkout") && is_checkout()
        || function_exists("is_account_page") && is_account_page()
    );
}

/**
 * Get button content by type
 * @param null $type
 */

function ggt_button_content($type = null)
{

    ggt_single_home_check();

    switch ($type):

        case "share":
            get_template_part("part-share");
            break;

        case "woocart":
            ?>
            <div class="widget_shopping_cart_content"></div>
            <?php break;

        case "pfdetails":
            global $post;
            ?>
            <div class="pf-info-block">

                <div class="description"><?php echo apply_filters("the_content", $post->post_content); ?></div>

                <?php
                if (ggt_have_rows('custom_fields', $post->ID)):
                    while (ggt_have_rows('custom_fields', $post->ID)) : ggt_the_row(); ?>
                        <div class="portfolio-item-custom">
                            <?php the_sub_field('field_name', $post->ID); ?> :
                            <?php the_sub_field('field_value', $post->ID); ?><br>
                        </div>
                    <?php endwhile; ?>
                <?php endif; ?>

                <?php if (!theme_option("hide_portfolio_date")): ?>
                    <div class="blog-date"><?php echo esc_html(date("F j, Y", strtotime($post->post_date))); ?></div>
                <?php endif; ?>

                <div class="categories"><?php
                    $categories = wp_get_post_terms($post->ID, 'project-type');
                    foreach ($categories as $cat): ?>
                        <div class="category-item">
                            <a href="<?php echo esc_url(get_term_link($cat)); ?>"><?php echo esc_html($cat->name); ?></a>
                        </div>
                    <?php endforeach; ?>
                </div>

                <?php if (ggt_get_field("show_button", $post->ID)): ?>
                    <div class="button">
                        <a href="<?php echo esc_url(ggt_get_field("portfolio_link", $post->ID)); ?>"><?php echo esc_html(ggt_get_field("portfolio_button_text", $post->ID)); ?></a>
                    </div>
                <?php endif; ?>

            </div>
            <?php
            break;

        case "pfprev":
            $ggt_previous = get_previous_post();
            if ($ggt_previous): ?>
                <a href="<?php echo esc_url(get_post_permalink($ggt_previous->ID)); ?>">
                    <div class="img-wrap image-cover"
                         style="background: url(<?php echo esc_url(ggt_get_featured($ggt_previous->ID, "small")); ?>); background-size: cover"></div>
                </a>
            <?php endif;
            break;

        case "pfnext":
            $ggt_next = get_next_post();
            if ($ggt_next): ?>
                <a href="<?php echo esc_url(get_post_permalink($ggt_next->ID)); ?>">
                    <div class="img-wrap image-cover"
                         style="background: url(<?php echo esc_url(ggt_get_featured($ggt_next->ID, "small")); ?>); background-size: cover"></div>
                </a>
            <?php endif;
            break;

        case "gridfilter":
            ?>
            <div id="grid-filter"></div>
            <?php break;

        case "cart":
            ?>
            <div class="purchase-info-block info-block">
                <div class="product-data-wrap"></div>
                <div class="addtocart-wrap">
                    <form class="gallery_cart" method="post" enctype="multipart/form-data">
                        <label><?php _e("Quantity:", "GoGetThemes"); ?>
                            <input type="number" value="1" name="quantity" class="quantity"/></label>

                        <div class="button">
                            <a href="#" class="add-to-cart-gallery"><?php _e("Add to cart", "GoGetThemes"); ?></a>
                        </div>
                    </form>
                </div>
                <div class="message-window"></div>
            </div>
            <?php break;

        case "contacts":
            ?>
            <div id="contacts-popup-bar">
                <div class="contacts-popup-inner">

                    <div id="contacts-bar" class="contact-info">
                        <div class="contacts-iconblock row">
                            <?php if (theme_option('header_phone')): ?>
                                <div class="phone text-center">
                                    <div class="contacts-icon">
                                        <i class="ggticon ggticon-Smartphone-4"></i>
                                    </div>
                                    <h5 class="contacts-title"><?php _e('Phone:', 'GoGetThemes') ?></h5>

                                    <div
                                        class="contacts-txt"><?php echo esc_html(theme_option('header_phone')); ?></div>
                                </div>
                            <?php endif; ?>
                            <?php if (theme_option('admin_email')): ?>
                                <div class="mail text-center">
                                    <div class="contacts-icon">
                                        <i class="ggticon ggticon-Mail"></i>
                                    </div>
                                    <h5 class="contacts-title"><?php _e('E-mail:', 'GoGetThemes') ?></h5>

                                    <div class="contacts-txt"><?php echo esc_html(theme_option('admin_email')); ?></div>
                                </div>
                            <?php endif; ?>
                            <?php if (theme_option('your_address')): ?>
                                <div class="address text-center">
                                    <div class="contacts-icon">
                                        <i class="ggticon ggticon-Map-Marker2"></i>
                                    </div>
                                    <h5 class="contacts-title"><?php _e('Address:', 'GoGetThemes') ?></h5>

                                    <div
                                        class="contacts-txt"><?php echo esc_html(theme_option('your_address')); ?></div>
                                </div>
                            <?php endif; ?>
                        </div>
                    </div>

                    <div id="contact-form-wrap" class="active">
                        <div id="contact-form" class="contact-form">
                            <?php
                            $cf7 = ggt_get_field('contact_form');
                            if ($cf7): ?>
                                <h3><?php _e("Quick feedback", "GoGetThemes"); ?></h3>
                                <?php
                                echo apply_filters('the_content', '[contact-form-7 id="' . $cf7->ID . '" title="Contact Us"]');
                            endif; ?>
                        </div>
                    </div>
                    <div class="close-popup"><span><?php _e("Close", "GoGetTHemes"); ?></span></div>
                </div>
            </div>
            <?php break;

        case "about":
            ?>
            <div class="about-wrap">
                <div class="about-img-wrap">
                    <img class="img-responsive about-img"
                         src="<?php echo esc_url(theme_option("about_photo", "url")); ?>"/>
                </div>
                <div class="about-block about-name">
                    <i class="ggticon ggticon-Administrator"></i>
                    <span class="contacts-text contacts-name"><?php echo esc_html(theme_option("about_name")); ?></span>
                </div>
                <div class="about-block about-text">
                    <span class="contacts-description"><?php echo esc_html(theme_option("top_about")); ?></span>
                </div>
                <div class="about-block about-email brd-top">
                    <i class="ggticon ggticon-Mail"></i>
                    <span class="contacts-text contacts-line"><a
                            href="mailto:<?php echo esc_attr(theme_option("admin_email")); ?>"><?php echo esc_html(theme_option("admin_email")); ?></a></span>
                </div>
                <div class="about-block about-phone brd-top">
                    <i class="ggticon ggticon-Smartphone-4"></i>
                    <span
                        class="contacts-text contacts-line"><?php echo esc_html(theme_option("header_phone")); ?></span>
                </div>
            </div>
            <?php break;

        case "link":
			break;

        default:
            break;
    endswitch;
}

function ggt_is_fullscreen()
{
    return (
        (is_singular("photogallery") && ggt_get_field("gallery_display_type") != "grid")
        || (is_page_template("page-calendar.php"))
        || (is_page_template("page-hover-slider.php"))
        || (is_page_template("page-image.php"))
        || (is_page_template("page-kenburns.php"))
        || (is_page_template("page-layer.php"))
        || (is_page_template("page-revolution.php"))
        || (is_page_template("page-split.php"))
        || (is_page_template("page-striped.php"))
        || (is_page_template("page-video.php"))
        || (is_page_template("page-contact.php"))
        || (is_page_template("page-singlehome.php"))
    );
}

function ggt_hide_to_top()
{
    return ggt_is_fullscreen();
}

/**
 * Sidebur button
 * @param $id
 * @param $icon
 * @param $label
 * @param null $content_type
 */

function ggt_appbar_item($id, $icon, $label, $content_type = null, $wide = false)
{
    ?>
    <div id="<?php echo esc_attr($id); ?>" class="app-bar-item bar-item <?php echo $wide ? "wide" : ""; ?>">
        <div class="bar-item-icon">
            <i class="ggticon <?php echo esc_attr($icon); ?>"></i>
        </div>
        <div class="bar-item-label">
        	<?php if($content_type=="link"){ ?>
				<a class="inside" 
					<?php if (ggt_get_field("sidebar_link")){echo 'href="'.ggt_get_field("sidebar_link").'" ';}?>
					<?php if (ggt_get_field("sidebar_link_target")){echo 'target="_blank" ';}?>
				>
					<?php echo esc_html($label); ?>
				</a>
            <?php }else{?>
            	<div class="inside"><?php echo esc_html($label); ?></div>
            <?php }?>
        </div>
        <div class="bar-content">
            <?php ggt_button_content($content_type); ?>
        </div>
    </div>
<?php
}

function ggt_get_bar_name($name)
{
    $real_name = $name; //default;

    switch ($name) {
        case "Contact us":
            $real_name = theme_option("bar_contact_us") ? theme_option("bar_contact_us") : $name;
            break;

        case "About":
            $real_name = theme_option("bar_about") ? theme_option("bar_about") : $name;
            break;

        case "Purchase":
            $real_name = theme_option("bar_purchase") ? theme_option("bar_purchase") : $name;
            break;

        case "Info":
            $real_name = theme_option("bar_info") ? theme_option("bar_info") : $name;
            break;

        case "Share":
            $real_name = theme_option("bar_share") ? theme_option("bar_share") : $name;
            break;

        case "Zoom":
            $real_name = theme_option("bar_zoom") ? theme_option("bar_zoom") : $name;
            break;

        case "Details":
            $real_name = theme_option("bar_details") ? theme_option("bar_details") : $name;
            break;

        case "Next":
            $real_name = theme_option("bar_next") ? theme_option("bar_next") : $name;
            break;

        case "Prev":
            $real_name = theme_option("bar_prev") ? theme_option("bar_prev") : $name;
            break;

        case "Categories":
            $real_name = theme_option("bar_categories") ? theme_option("bar_categories") : $name;
            break;

        case "View cart":
            $real_name = theme_option("bar_cart") ? theme_option("bar_cart") : $name;
            break;

        case "Play":
            $real_name = theme_option("bar_play") ? theme_option("bar_play") : $name;
            break;

        case "Mute":
            $real_name = theme_option("bar_mute") ? theme_option("bar_mute") : $name;
            break;

        case "Link":
            $real_name = ggt_get_field("sidebar_link_label") ? ggt_get_field("sidebar_link_label") : $name;
            break;

        default:
            break;
    }

    return $real_name;
}

function ggt_theme_appbar()
{
    $page_type = "default";
    $need_responsive_nav = false;
    $need_video_controls = false;

    if (is_singular("photogallery") && ggt_get_field("gallery_display_type") != "grid" && ggt_get_field("gallery_display_type") != "kenburns") {
        $page_type = "photogallery";
        $need_responsive_nav = true;
    } else if (is_singular("portfolio")) {
        $page_type = "portfolio";
        if (ggt_get_field("work_type") == "video") {
            $need_video_controls = true;
        }
    } else if (
        is_page_template("page-portfolio.php")
        || is_page_template("page-blog.php")
        || is_page_template("page-gallery-grid.php")
    ) {
        $page_type = "gridpage";
    } else if (function_exists("is_woocommerce") && is_woocommerce() || ggt_is_woo_page()) {
        $page_type = "woopage";
    } else if (is_page_template("page-singlehome.php")) {
        if ("portfolio" == ggt_get_field("home_post_type")) {
            $page_type = "portfolio";
            $project = ggt_get_field("portfolio");
            if (ggt_get_field("work_type", $project->ID) == "video") {
                $need_video_controls = true;
            }
        } else {
            $post_object = ggt_get_field("photogallery");
            if ($post_object) {
                if ("grid" != ggt_get_field("gallery_display_type", $post_object->ID) && "kenburns" != ggt_get_field("gallery_display_type", $post_object->ID)) {
                    $page_type = "photogallery";
                    $need_responsive_nav = true;
                } else if ("grid" == ggt_get_field("gallery_display_type", $post_object->ID)) {
                    $page_type = "gridpage";
                }
            }
        }
    }

    if (is_page_template("page-split.php")) {
        $need_responsive_nav = true;
    }

    if (is_page_template("page-video.php")) {
        $need_video_controls = true;
    }

    // sidebar wrap start
    ?>
    <div id="main-app-bar" class="app-bar shown layout-right">
        <?php

        if (is_page_template("page-contact.php")):
            ggt_appbar_item("bar-map-info", "ggticon-Envelope", ggt_get_bar_name("Contact us"), "contacts", true);
        endif;

        if (theme_option("about_switch")):
            ggt_appbar_item("bar-about", "ggticon-Information", ggt_get_bar_name("About"), "about");
        endif;

        if (ggt_get_field("sidebar_link_label")):
        	(ggt_get_field("sidebar_link_ico")) ? $link_ico = ggt_get_field("sidebar_link_ico") : $link_ico = "ggticon-Broke-Link2";
        	ggt_appbar_item("bar-link", $link_ico, ggt_get_bar_name("Link"), "link");
        endif;

        switch ($page_type):

            case "photogallery":
                ggt_appbar_item("bar-cart", "ggticon-Shopping-Cart", ggt_get_bar_name("Purchase"), "cart", true);
                ggt_appbar_item("bar-details", "ggticon-File-HorizontalText", ggt_get_bar_name("Info"));
                ggt_appbar_item("bar-share", "ggticon-Heart", ggt_get_bar_name("Share"), "share");
                ggt_appbar_item("bar-mobile-zoom", "ggticon-Eye-Scan", ggt_get_bar_name("Zoom"));
                break;

            case "portfolio":
                ggt_appbar_item("bar-details", "ggticon-File-HorizontalText", ggt_get_bar_name("Details"), "pfdetails");
                ggt_appbar_item("bar-share", "ggticon-Heart", ggt_get_bar_name("Share"), "share");
                ggt_appbar_item("bar-pf-next", "ggticon-Right", ggt_get_bar_name("Next"), "pfnext");
                ggt_appbar_item("bar-pf-prev", "ggticon-Left", ggt_get_bar_name("Prev"), "pfprev");
                break;

            case "gridpage":
                if (ggt_get_field("enable_filter")) {
                    ggt_appbar_item("bar-filter", "ggticon-Filter-2", ggt_get_bar_name("Categories"), "gridfilter");
                }
                ggt_appbar_item("bar-share", "ggticon-Heart", ggt_get_bar_name("Share"), "share");
                break;

            case "woopage":
                if (!is_cart() && !is_checkout()):
                    ggt_appbar_item("bar-woocart", "ggticon-Shopping-Cart", ggt_get_bar_name("View cart"), "woocart", true);
                endif;
                ggt_appbar_item("bar-share", "ggticon-Heart", ggt_get_bar_name("Share"), "share");
                break;

            default:
                ggt_appbar_item("bar-share", "ggticon-Heart", ggt_get_bar_name("Share"), "share");
                break;

        endswitch;

        if ($need_responsive_nav):
            ggt_appbar_item("bar-mobile-next", "ggticon-Right", ggt_get_bar_name("Next"));
            ggt_appbar_item("bar-mobile-prev", "ggticon-Left", ggt_get_bar_name("Prev"));
        endif;

        if ($need_video_controls):
            ggt_appbar_item("bar-video-play", "ggticon-Start2", ggt_get_bar_name("Play"));
            ggt_appbar_item("bar-video-mute", "ggticon-Speaker-2", ggt_get_bar_name("Mute"));
        endif;

        ?>

        <?php if (theme_option("show_copyright")): ?>
            <div id="bar-copyright">
                <?php echo wp_kses_post(theme_option("copyright_text")); ?>
            </div>
        <?php endif; ?>
    </div>
<?php
}

function ggt_theme_footerbar()
{
    global $deviceType;
    ?>
    <div id="footer-bar" class="app-bar">

        <div id="toggle-sidebar" class="footer-bar-item bar-item">
            <div class="bar-item-icon">
                <i class="ggticon-Arrow-Outside"></i>
            </div>
            <div class="bar-label">

            </div>
        </div>


        <?php
        if ($deviceType == "computer") {
            get_template_part("part-audioplayer");
        }
        ?>

        <?php if (!ggt_hide_to_top()): ?>
            <div id="back-to-top" class="footer-bar-item bar-item">
                <div class="bar-item-icon">
                    <i class="ggticon ggticon-Up"></i>
                </div>
                <div class="bar-label">
                    Top
                </div>
            </div>
        <?php endif; ?>

        <div id="footer-social" class="footer-bar-item bar-item">
            <div class="bar-item-icon">
                <div class="dots-wrap">
                    <i class="dot dot-one"></i>
                    <i class="dot dot-two"></i>
                    <i class="dot dot-three"></i>
                </div>
            </div>
            <?php get_template_part("part-social"); ?>
        </div>
    </div>
<?php
}